#ifndef _ENEMIES_H
#define _ENEMIES_H

#define ENEMIES_IN_SCREEN   10

 
#define DEAD                 0
#define ALIVE                1

#define ENEMY_X             40
#define ENEMY_Y             40


struct struct_enemy_shot
{
 	int x;
	int y;
	
	int state;
	
	BITMAP *bmp;
	
	void draw(BITMAP *where);
	void logic();

};

void struct_enemy_shot::draw(BITMAP *where)
{
 	 if(state==ACTIVE)
 	 {
 	     draw_sprite(where,bmp,x,y);
	 }
}
 	 
void struct_enemy_shot::logic()
{
 	 if(state==ACTIVE)
 	 {
	     y+=6;
	     if(y>480)
	     {
  		     state=INACTIVE;
		 }
     }
}

 	 

struct struct_enemy
{
    int x;
    int y;
    
    int hp;
    int next_shot;
    
    int level;
    
    fix base_x;
    
    int state;
    
    int length;
    fix angle;
    
    struct_enemy_shot shot[3];
    
    BITMAP *bmp;
    
    void draw(BITMAP *where);
    void logic();
    
}enemy[ENEMIES_IN_SCREEN];


void struct_enemy::draw(BITMAP *where)
{
    if(state==ALIVE)
    {
        draw_sprite(where,bmp,x,y);
	}
}

void struct_enemy::logic()
{
 	 if(state==ALIVE)
 	 {

 	     y+=(1+level);
	
 	     if(y>480)
		 {      
		 		state=DEAD;
		 }
		 
		 if((rand() % (450-(80*level)))==0)
		 {
             if(shot[next_shot].state==INACTIVE)
             {
                 shot[next_shot].state=ACTIVE;
                 shot[next_shot].x=(x+(ENEMY_X/2));
                 shot[next_shot].y=(y+ENEMY_Y);
                 
                 
                 if(next_shot>=2)
                 {
			         next_shot++;
			     }
			     else
			     {
			  	     next_shot=0;
			     }
			 }
		 }
     
         angle+=4;
     
         if(angle>=255) angle = 0;
     
         x=base_x+(length*sin(angle));
	 }
	 else
	 {
	     if((rand() % 60)==0)
	     {
	         angle=0;
	         hp=((4+(level*3))-spaceship.damage);
	         if(hp<=0)
			 { 
 		         hp=1;
			 }
	         base_x=40+(rand() % 440);
	         x=base_x;
	         y=-40;
	         length=5+(rand() % 25);
		     state=ALIVE;
		     int a=rand() % 3;
		     if(a==0)
		     {
		  		 bmp=(BITMAP *)data[ENEMY1+(level*3)].dat;
			 }
			 else if(a==1)
		     {
		  		 bmp=(BITMAP *)data[ENEMY2+(level*3)].dat;
			 }
		     else if(a==2)
		     {
		  		 bmp=(BITMAP *)data[ENEMY3+(level*3)].dat;
			 }
         }
     }    
}



#endif
