#ifndef _INIT_H
#define _INIT_H

#include <allegro.h>

void init();
void deinit();

BITMAP   *buffer;
DATAFILE *data; 

void init() {
	allegro_init();

	set_color_depth(16);
	if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0)) 
	{
		allegro_message(allegro_error);
		exit(-1);
	}

	install_timer();
	install_keyboard();
	install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT, NULL);
	load_midi_patches();
	
	srand(time(0));
	
	buffer = create_bitmap(640,480);
	data   = load_datafile("data.dat");
}

void deinit() 
{

	clear_keybuf();
	unload_datafile(data);
	destroy_bitmap(buffer);
	allegro_exit();
	
}


#endif
