#ifndef _SPACESHIP_H
#define _SPACESHIP_H

#include <allegro.h>

#define INACTIVE 0
#define ACTIVE   1

struct struct_shot
{
 	   int x;
 	   int y;
 	   
	   int state;
	   
  	   void logic();
 	   void draw(BITMAP *where,BITMAP *which);
};

void struct_shot::draw(BITMAP *where,BITMAP *which)
{
 	 if(state==ACTIVE)
 	 {
 	     draw_sprite(where,which,x,y);
	 }
}


void struct_shot::logic()
{
 	 if(state==ACTIVE)
 	 {
    	 y-=8;
 	     if(y<0)
 	     {
	  		 state=INACTIVE;
         }
	 }
}
 	   

struct struct_spaceship
{
 	   int x;
 	   int y;
 	   int state;
 	   int damage;
 	   
 	   int next_shot;
 	   
 	   int allowed_shot;
 	   
       BITMAP *bmp;
       
       struct_shot shot[20];
 	   
 	   void logic();
 	   void draw(BITMAP *where);
 	   
}spaceship;


void struct_spaceship::draw(BITMAP *where)
{
 	 draw_sprite(where,bmp,x,y);
}

void struct_spaceship::logic()
{
 	 if(!key[KEY_LCONTROL])
 	 {
         allowed_shot=1;
	 }
 	 
 	 if(key[KEY_UP]    && y>4)      y-=6;
 	 if(key[KEY_RIGHT] && x<475)    x+=6;
 	 if(key[KEY_DOWN]  && y<435)    y+=6;
 	 if(key[KEY_LEFT]  && x>4)      x-=6;

 	 if(key[KEY_LCONTROL])
 	 {
         if(shot[next_shot].state==INACTIVE && allowed_shot==1)
		 {
		     shot[next_shot].state=ACTIVE;
		     shot[next_shot].x=x+17;
		     shot[next_shot].y=y;
	     
    	  	 next_shot++;
    	  	 allowed_shot=0;
		 }
	     if(next_shot>=20)
	     {
	         next_shot=0;
		 }
	 }
	 clear_keybuf();	 
}


#endif
